#include <windows.h>
#include <stdio.h>

#include "resource.h"

/*  Declare Windows procedure  */
LRESULT CALLBACK WindowProcedure (HWND, UINT, WPARAM, LPARAM);

/*  Make the class name into a global variable  */
char szClassName [] = "WindowsApp";

int WINAPI WinMain (HINSTANCE hThisInstance,
                    HINSTANCE hPrevInstance,
                    LPSTR lpszArgument,
                    int nFunsterStil)

{
 HWND hwnd;               /* This is the handle for our window */
 MSG messages;            /* Here messages to the application are saved */
 WNDCLASSEX wincl;        /* Data structure for the windowclass */

 /* The Window structure */
 wincl.hInstance = hThisInstance;
 wincl.lpszClassName = szClassName;
 wincl.lpfnWndProc = WindowProcedure;      /* This function is called by windows */
 wincl.style = CS_DBLCLKS;                 /* Catch double-clicks */
 wincl.cbSize = sizeof (WNDCLASSEX);

 /* Use default icon and mouse-pointer */
 wincl.hIcon = LoadIcon (hThisInstance, MAKEINTRESOURCE (ID_PIC));
 wincl.hIconSm = LoadIcon (hThisInstance, MAKEINTRESOURCE (ID_PIC));
 wincl.hCursor = LoadCursor (NULL, IDC_ARROW);
 wincl.lpszMenuName = NULL;                 /* No menu */
 wincl.cbClsExtra = 0;                      /* No extra bytes after the window class */
 wincl.cbWndExtra = 0;                      /* structure or the window instance */
 /* Use Windows's default color as the background of the window */
 wincl.hbrBackground = (HBRUSH) COLOR_BACKGROUND;

 /* Register the window class, and if it fails quit the program */
 if (!RegisterClassEx (&wincl))
  return 0;


 FILE *file;
 int i, dir_l=0, size;
 bool bat=false;
 char FilePath [_MAX_PATH], AppDir [_MAX_PATH], cfgPath [_MAX_PATH],
      DOSBoxPath [_MAX_PATH], DOSAppPath [_MAX_PATH], DOSAppDir [_MAX_PATH],
      DOSAppFake [_MAX_PATH], DOSAppExe [_MAX_PATH], RunPath [_MAX_PATH];
 char mess [256], err [32]={""};

 //    
 memset (FilePath, 0, _MAX_PATH);
 GetModuleFileName (NULL, FilePath, _MAX_PATH);
 for (i=_MAX_PATH-1; i>=0 && dir_l==0; i--)
 {
  if (FilePath [i]=='\\')
   dir_l=i+1;
 }
 for (i=0; i<dir_l; i++)
  AppDir [i]=FilePath [i];

 // ... "config.txt"
 memset (cfgPath, 0, _MAX_PATH);
 memcpy (cfgPath, AppDir, dir_l);
 strcat (cfgPath, "data\\config.txt");

 //    "DOSBox.exe"
 file=fopen (cfgPath, "rb");
 if (file!=NULL)
 {
  fgets (DOSBoxPath, _MAX_PATH, file);
  fclose (file);
 }

 //   
 file=fopen (DOSBoxPath, "rb");
 if (file!=NULL)
 {
  fclose (file);

  if (lpszArgument [0]==0)//   
  {
   char mess_ar [5] [64]={"  -  DOS- (.exe, .com, .bat),",
                          "    .dos"
                         };
   sprintf (mess, "%s\n%s", mess_ar [0], mess_ar [1]);
   MessageBox (NULL, mess, err, MB_OK);
  }
  else
  {
   //    DOS-
   if (lpszArgument [0]=='"')//   
   {
    memset (DOSAppPath, 0, _MAX_PATH);
    for (i=1; i<strlen (lpszArgument)-1; i++)
     DOSAppPath [i-1]=lpszArgument [i];
   }
   else
    sprintf (DOSAppPath, "%s", lpszArgument);
   file=fopen (DOSAppPath, "rb");
   if (file!=NULL)
   {
    fseek (file, 0, SEEK_END);
    size=ftell (file);
    fclose (file);

    //      ,
    //    
    if (size<512)
     bat=true;
   }

   //     .dos-
   dir_l=0;
   for (i=_MAX_PATH-1; i>=0 && dir_l==0; i--)
   {
    if (DOSAppPath [i]=='\\')
     dir_l=i+1;
   }
   memset (DOSAppDir, 0, _MAX_PATH);
   for (i=0; i<dir_l; i++)
    DOSAppDir [i]=DOSAppPath [i];
   memset (DOSAppFake, 0, _MAX_PATH);
   for (i=dir_l; i<strlen (DOSAppPath); i++)
    DOSAppFake [i-dir_l]=DOSAppPath [i];

   // ... .exe-
   sprintf (DOSAppExe, "%s", DOSAppFake);
   if (bat)
   {
    DOSAppExe [strlen (DOSAppExe)-3]='b';
    DOSAppExe [strlen (DOSAppExe)-2]='a';
    DOSAppExe [strlen (DOSAppExe)-1]='t';
   }
   else
   {
    DOSAppExe [strlen (DOSAppExe)-3]='e';
    DOSAppExe [strlen (DOSAppExe)-2]='x';
    DOSAppExe [strlen (DOSAppExe)-1]='e';
   }

   //  
   SetCurrentDirectory (DOSAppDir);

   //  .dos-  .exe-
   CopyFile (DOSAppFake, DOSAppExe, false);

   //   
   file=fopen (DOSAppExe, "rb");
   if (file!=NULL)
   {
    fclose (file);

    //    DOSBox
    sprintf (RunPath, "\"%s\" %s -exit", DOSBoxPath, DOSAppExe);
    system (RunPath);

    //   
    DeleteFile (DOSAppExe);
   }
   else
   {
    sprintf (mess, "    : \"%s\"\n\n", DOSAppExe);
    MessageBox (NULL, mess, err, MB_OK);
   }
  }
 }
 else
 {
  sprintf (mess, "DOSBox  .      \"%s\"\n\n", cfgPath);
  MessageBox (NULL, mess, err, MB_OK);
 }


 // 
 PostQuitMessage (0);       /* send a WM_QUIT to the message queue */

 /* Run the message loop. It will run until GetMessage() returns 0 */
 while (GetMessage (&messages, NULL, 0, 0))
 {
  /* Translate virtual-key messages into character messages */
  TranslateMessage(&messages);
  /* Send message to WindowProcedure */
  DispatchMessage(&messages);
 }

 /* The program return-value is 0 - The value that PostQuitMessage() gave */
 return messages.wParam;
}


/*  This function is called by the Windows function DispatchMessage()  */
LRESULT CALLBACK WindowProcedure (HWND hwnd, UINT message, WPARAM wParam, LPARAM lParam)
{
 switch (message)             /* handle the messages */
 {
  default:                    /* for messages that we don't deal with */
   return DefWindowProc (NULL, message, wParam, lParam);
 }

 return 0;
}
